﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms;
using System.Collections.ObjectModel;

namespace Pie_series
{
    public class Pie : ContentPage
    {
        StackLayout rootLayout;
		SimpleWrapLayout legendLayout;
        ObservableCollection<ChartDataPoint> data;
        PieSeries pieseries;
        Color[] customColors;

        public Pie()
        {
            customColors = new Color[12];
			customColors [0] = Color.Accent;
			customColors [1] = Color.Aqua;
			customColors [2] = Color.Yellow;
			customColors [3] = Color.Purple;
			customColors [4] = Color.Gray;
			customColors [5] = Color.Green;
			customColors [6] = Color.Lime;
			customColors [7] = Color.Maroon;
			customColors [8] = Color.Purple;
			customColors [9] = Color.Red;
			customColors [10] = Color.Silver;
			customColors [11] = Color.Navy;

            rootLayout = new StackLayout();
            rootLayout.VerticalOptions = LayoutOptions.FillAndExpand;

            SfChart chart = new SfChart();
            chart.VerticalOptions = LayoutOptions.FillAndExpand;
            chart.Title.Text = "Pie Series";

			legendLayout = new SimpleWrapLayout();
			legendLayout.Padding = new Thickness (10, 0, 0, 20);
			legendLayout.HorizontalOptions = LayoutOptions.StartAndExpand;

            data = new ObservableCollection<ChartDataPoint>();
            data.Add(new ChartDataPoint("Jan", 15));
            data.Add(new ChartDataPoint("Feb", 10));
            data.Add(new ChartDataPoint("Mar", 20));
            data.Add(new ChartDataPoint("Apr", 25));
            data.Add(new ChartDataPoint("May", 15));
            data.Add(new ChartDataPoint("Jun", 10));
            data.Add(new ChartDataPoint("Jul", 20));
            data.Add(new ChartDataPoint("Aug", 25));
            data.Add(new ChartDataPoint("Sep", 15));
            data.Add(new ChartDataPoint("Oct", 10));
            
            BoxView boxview;
            Label label;

            for (int i = 0; i < data.Count; i++)
            {
                boxview = new BoxView();
                boxview.HeightRequest = 12;
                boxview.WidthRequest = 12;
                boxview.Color = GetColor(i);

                label = new Label();
                label.TextColor = Color.Black;
                label.Text = (data[i] as ChartDataPoint).XValue.ToString();

				StackLayout stack = new StackLayout();
				stack.Orientation = StackOrientation.Horizontal;

				stack.Children.Add (boxview);
				stack.Children.Add (label);

				legendLayout.Children.Add (stack);
            }
          
            pieseries = new PieSeries();
            pieseries.ColorModel.Palette = ChartColorPalette.Custom;
            pieseries.ColorModel.CustomBrushes = customColors;
            pieseries.ItemsSource = data;
            pieseries.DataMarker = new ChartDataMarker();
            pieseries.DataMarkerPosition = CircularSeriesDataMarkerPosition.OutsideExtended;

            chart.Series.Add(pieseries);

			rootLayout.Children.Add(chart);
            rootLayout.Children.Add(legendLayout);

            Content = rootLayout;           
        }

        Color GetColor(int i)
        {
            return customColors[i];
        }
    }
}

